#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Mailer::Report module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Mailer::Report';

        use_ok('Tester');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Mailer::Report::VERSION

### Attempting to create Mentat::Mailer::Report instance...
my $instance = $TESTED_CLASS->service();
isa_ok($instance, $TESTED_CLASS);

### Viewing the created instance: $instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D(2);

my ($rc, $result) = $instance->email_report({
        id => 'M20140203-0010',
        type => 'summary',
        abuse => 'test@omnius.cesnet.cz',
        to => 'test@omnius.cesnet.cz',
        message => 'Test message',
        attachment_file1 => 'security_report_m20140203-0010.csv.zip',
    }, redirect => 1);
is($rc, 1, "Email test 01");
diag($result) if Tester::D();
