#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Storage::Factory module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 6;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Storage::Factory';

        use_ok('Tester');
        use_ok($TESTED_CLASS);
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Mentat::Storage::Factory::VERSION) if Tester::D();

# Now attempt to create a class instance and check it
#my $instance = $TESTED_CLASS->new();
#isa_ok($instance, $TESTED_CLASS);

# View the created instance
#diag("Instance dump 01: " . Dumper($instance)) if Tester::D();

my $engine1 = Mentat::Storage::Factory->storage('mongo_raw', database => 'mentat', collection => 'unittest');
isa_ok($engine1, 'Mentat::Storage');
isa_ok($engine1, 'Mentat::Storage::Mongo');

my $engine2 = Mentat::Storage::Factory->storage('mongo', database => 'mentat', collection => 'unittest');
isa_ok($engine2, 'Mentat::Storage');
isa_ok($engine2, 'Mentat::Message::Storage::Mongo');
